%% commands for SH as consistent 2nd order sys, 1D  
keep pphome; close all; p=[]; 
%% init and zero-branch 
lx=5*pi; nx=round(2*lx); ly=5.1*pi; % ly=6; ly=8; 
ny=1; ndim=2; lam=-0.01; nu=0; kap=1; 
par=[lam; nu; kap]; p=shinit(p,nx,lx,ly,ndim,par); huclean(p); p.np, plotsol(p,1,1,1); pause 
p.nc.dsmin=1e-6; p.sw.eigstart=0; ds=0.1; p.sol.ds=ds; p.file.smod=1; %p=box2per(p,2); 
p=setfn(p,'2D0'); p.nc.bisecmax=10; p.sw.bifcheck=0; p=cont(p,1); p0=p; %p=findbif(p,1);
%%
p=p0; k=9/10; lam=(k^2-1)^2, p=setlam(p,lam-ds); p.sol.ds=ds; p=cont(p,1); 
%% Turing-branches 2 and 3 (wave-numbers 9/10 and 11/10 (for lx=10*pi))
% resp. 19/20 and 21/20 for lx=20*pi
huclean(p); aux.m=6; aux.soltol=1e-30;   p0=qswibra('2D0','pt1',aux); pause; huclean(p); 
%%
p=gentau(p0,[0 0 0 0 0 1],'s1'); p.sw.bifcheck=2; p=cont(p,10); 
%%
p0=qswibra('s1','bpt2',aux); pause; huclean(p); 
p=gentau(p0,[0 0 0 0 0 1],'s2'); p.sw.bifcheck=2; p=cont(p,10);
%%
p=swibra('s3','bpt5','3-2',0.001);  p=cont(p,10);
%%
p=swibra('2D0','bpt3','2D3',0.001);  p=cont(p,2);
%% plot first 3 branches 
figure(3); clf; cmp=4; wnr=3; 
plotbra('1D1','pt10',wnr,cmp,'cl','k','lsw',0); plotbra('1D2','pt10',wnr,cmp,'cl','r'); 
plotbra('1D3','pt15',wnr,cmp,'cl','m');
axis([0 0.05 0 0.1]); 
%% continuation of BP1 from 0 in kap (to obtain 'existence of stripes' region) 
figure(2); clf; p=bpcontini('1D0','bpt1',3,'bpc0a'); p.sol.ds=0.01; 
p.nc.lammin=-1; p.plot.bpcmp=1; p.sw.spjac=1; p.nc.del=1e-2; 
p.fuha.spjac=@bpjac; p.sw.spcalc=0; p.sw.bifcheck=0;
p.nc.tol=1e-8; p.file.smod=5; huclean(p); p0=p;  p=cont(p,10); 
%p=p0; p.sol.ds=-p.sol.ds; p=setfn(p,'bpc0b'); p=cont(p,10); 
%% continuation in kap of BP2 on b2: b2 gains stability here; wave-nr is 19/20, i.e., 
% dilated wave, hence continue to kap<1 for 'further dilation' 
figure(2); clf; p=bpcontini('s5','bpt3',3,'2Dbpc5'); p.sol.ds=0.01; 
p.nc.lammin=-1; p.plot.bpcmp=1; p.sw.spjac=1; p.nc.del=1e-4; 
p.fuha.spjac=@bpjac; p.sw.spcalc=0; p.sw.bifcheck=0;
p.nc.tol=1e-6; p.file.smod=5; huclean(p); p=cont(p,20); 
%%  continuation in kap of BP3 on b3: b3 gains stability here; wave-nr is 21/20, i.e., 
% compressed wave, hence continue to kap>1 for 'further compression' 
figure(2); clf; p=bpcontini('1D3','bpt3',3,'bpc3a'); p.sol.ds=0.01; 
p.nc.lammin=-1; p.plot.bpcmp=1; p.sw.spjac=1; p.nc.del=1e-4; 
p.fuha.spjac=@bpjac; p.sw.spcalc=0; p.sw.bifcheck=0;
p.nc.tol=1e-8; p.file.smod=5; huclean(p); p=cont(p,20); 
%% plot 'existence line' (BP continuation of prim.bif) and 
% stability lines (conts of BPs where sideband branches become stable) 
figure(3); clf; 
plotbra('bpc0a','pt10'); plotbra('bpc0b','pt10'); 
plotbra('bpc2a','pt20','cl','r'); 
plotbra('bpc3a','pt20','cl','r'); 
k=linspace(0.75,1.25,20); kap=k.^2-1;
figure(3); hold on; plot(k,kap.^2,'*k'); % analytical existence line
plot(k,3*kap.^2-kap.^3,'*r'); 
%axis([0.75 1.25 0 1]); 
%% jaccheck for BC, numjac just doesn't work 
[Ja, Jn]=bpjaccheck(p); Jd=abs(Ja-Jn); me=max(max(Jd)), spy(Jd>me/100); 
%% BP cont exit
huclean(p); p=bpcontexit('bpc1','pt5','1D2b'); %p=cont(p,10); 
