function p=hocont(p,varargin)
% hocont: cont for Hopf; also called by cont if p.sol.ptype=3 
msteps=p.nc.nsteps; if nargin>1; msteps=varargin{1};  end
p.fuha.headfu(p); is=0; lastds=p.sol.ds; 
if p.sol.restart==1; [p,flag]=hoinistep(p,p.sol.ds); % tomsol to find points on branch
    p.hopf.xi=1/p.nu; 
   if flag~=0; return; end  
   p.sol.restart=0; is=2; 
   if p.sw.para~=3; p=tom2arc(p); end 
end
tl=p.hopf.tl; nqh=p.hopf.nqh; na=p.nu+p.nc.nq;  % just some shorthands 
while is<msteps 
    switch p.sw.para; 
    case 3 % nat.para (note: no stepsize control yet!) 
       lam0=getlam(p); lam1=lam0+p.sol.ds*p.hopf.ysec(end,1); %lam1=lam0+p.sol.ds; 
       p=setlam(p,lam1); y0=p.hopf.y; t0=p.hopf.t; tl0=length(p.hopf.t); 
       p.hopf.y=p.hopf.y+p.sol.ds*p.hopf.ysec; % predictor 
       p=tomsol(p);
       if length(p.hopf.t)~=tl0; y0=interp1(t0,y0',p.hopf.t); y0=y0'; end % meshref in tom 
       par=p.u(p.nu+1:end); f0=horhs(0,p.hopf.y(:,1),p,par); p.hopf.u0dot=f0(1:p.nu); 
       p.hopf.y=[p.hopf.y; lam1*ones(1,length(p.hopf.t))]; % append lam-line 
       p.hopf.ysec=(p.hopf.y-y0); %/p.sol.ds; 
       p.hopf.ysec=p.hopf.ysec/honorm(p,p.hopf.ysec); % new secant
    case 4 % arclength
       if ~isfield(p.hopf,'tau'); p=tom2arc(p); end % convert tom-datastruc to vector 
       stepok=0; 
       while stepok==0; 
       y1=p.hopf.y+p.sol.ds*v2tom(p,p.hopf.tau);    % predictor
       T1=p.hopf.T+p.sol.ds*p.hopf.tau(na*tl+1); 
       lam0=p.hopf.lam; 
       lam1=lam0+p.sol.ds*p.hopf.tau(na*tl+2); 
       if nqh>0; s0=p.u(p.nu+p.hopf.ilam);   % Hopf with constraints, assume aux-vars 
        s1=s0+p.sol.ds*p.hopf.tau(na*tl+3:end)'; % aux-vars predictor, aux-tangent at end 
        p.u(p.nu+p.hopf.ilam)=s1;
        [y,T,lam,res,iter,A,p]=chonloopext(p,y1,T1,lam1,p.sol.ds); % corrector 
       else [y,T,lam,res,iter,A,p]=honloopext(p,y1,T1,lam1,p.sol.ds); 
       end 
       p.sol.iter=iter; lastds=p.sol.ds; [p,stepok]=hosscon(p,res,iter); 
       end
       if p.hopf.sec==1; ysec=(y-p.hopf.y); % use secant
         if nqh>0; sec2=[T-p.hopf.T; lam-lam0; p.u(p.nu+p.hopf.ilam)-s0]; 
         else sec2=[T-p.hopf.T; lam-lam0]; end 
         tau=[reshape(ysec,p.nu*tl,1);sec2]/p.sol.ds; 
       else % use tangent
         if nqh>0; [tau,p]=p.fuha.blss(A,[zeros(na*tl+1,1); 1; zeros(p.hopf.nqh,1)],p);
         else [tau,p]=p.fuha.blss(A,[zeros(p.nu*tl+1,1); 1],p); 
         end
       end 
       p.hopf.T=T; p.hopf.lam=lam; p.hopf.y=y; p.sol.res=res; p=setlam(p,lam);
       par=p.u(p.nu+1:end); p.hopf.y0d=sety0dot(p,p.hopf.y,par,p.hopf.T); % phase cond 
       hn=honorm(p,tau); tau=tau/hn; p.hopf.tau=tau'; 
     case 5 % nat.para, with honloop
       y1=p.hopf.y+p.sol.ds*v2tom(p,p.hopf.tau);    % predictor
       T1=p.hopf.T+p.sol.ds*p.hopf.tau(na*tl+1); 
       lam0=p.hopf.lam; lam1=lam0+p.sol.ds*p.hopf.tau(na*tl+2); 
       s0=p.u(p.nu+p.hopf.ilam); s1=s0+p.sol.ds*p.hopf.tau(na*tl+3); 
       p.u(p.nu+p.hopf.ilam)=s1; % init <s> with predictor 
       [y,T,lam,res,iter,A,p]=honloop_np(p,y1,T1,lam1,p.sol.ds); % corrector 
       % disp([lam0 lam1 lam s0 s1 p.u(p.nu+3)]); %pause 
       ysec=(y-p.hopf.y); sec2=[T-p.hopf.T; lam-lam0; p.u(p.nu+p.hopf.ilam)-s0]; 
       p.hopf.T=T; p.hopf.y=y; p.sol.res=res; 
       p.hopf.lam=lam; p=setlam(p,lam); % lam=lam1 but to keep the structure ...
       par=p.u(p.nu+1:end); 
       p.hopf.y0d=sety0dot(p,p.hopf.y,par,p.hopf.T);  % new phase cond 
      % for i=1:p.hopf.tl; f=hosrhs(0,p.hopf.y(:,i),p,par,p.hopf.T);    p.hopf.y0d(1:na,i)=f(1:na); end;  
       tau=[reshape(ysec,p.nu*tl,1);sec2]/p.sol.ds; % secant
       hn=honorm(p,tau); tau=tau/hn; p.hopf.tau=tau'; 
    end
    if isfield(p.hopf,'auxp'); p.hopf.auxp(p); end % auxiliary plot 
    ind=-1; 
    if p.sw.para>3 && p.hopf.flcheck>0           
      jac=A(1:p.nu*tl, 1:p.nu*tl); 
      if p.hopf.flcheck==1; [muv1, muv2, ind]=floq(p,jac); 
      else [muv1, muv2, ind]=floqps(p,jac);
      end
      %fprintf('ind=%i', ind); 
      if p.hopf.indini && ind~=p.hopf.oldind
         mucand=muv1(end-1); % candidate
         if ind>p.hopf.oldind; mucand=muv2(1); end % if new unstable multiplier(s)
         fprintf('possible Bif from Hopf, old-ind=%i, ind=%i, abs(mu)=%g, mu=%g+%gi\n', ...
             p.hopf.oldind, ind, abs(mucand), real(mucand), imag(mucand)); 
         %pnsav=p.file.pname; fname=[p.file.dir '/bph']; p.file.pname=fname;  
         p.fuha.savefu(p,5);
         %p.file.pname=pnsav; 
      end
      p.hopf.ind=ind; p.hopf.indini=1; p.hopf.oldind=ind;
      p.hopf.muv1=muv1; p.hopf.muv2=muv2; 
    end            
    p.sol.ptype=4; % regular point on Hopf branch
    brout=[bradat(p); p.fuha.outfu(p,p.u)];     % userfu to append to bif-branches  
    brplot=brout(length(bradat(p))+p.plot.bpcmp);    % y-axis value in bif-figure
    p.branch=[p.branch brout];                       % put on branch 
    if(p.file.count>0 && mod(p.file.count,p.file.smod)==0) % save to file 
       p.fuha.savefu(p); 
    end
    hoplot(p,p.plot.pfig,p.plot.pcmp); figure(p.plot.brfig); hold on; 
    if ind>0; plot(getlam(p),real(brplot),'+b'); drawnow; 
    else plot(getlam(p),real(brplot),'*b'); drawnow; end 
    [p,cstop]=p.fuha.ufu(p,brout,lastds); 
    is=is+1; p.file.count=p.file.count+1;
    if(cstop==1) break; end   
end
p.file.count=p.file.count-1; p.fuha.savefu(p); p.file.count=p.file.count+1; % final save 