function dia=sldiagn(p,wnr) % standard diagnostics, plot u_1, lam_1
% use as template to plot adapted diagnostics 
s1=p.oc.s1; u0=p.oc.u0; u1=p.oc.u1; 
sol=p.cp; T=sol.par(1); 
t=T*sol.t; y=sol.u; sl=length(t); np=s1.np; dia=zeros(2,sl); 
for i=1:sl
    dia(1,i)=norm(y(1:np,i)-u0(1:np),'inf'); % diff state from IC 
    dia(2,i)=norm(y(1:np,i)-u1(1:np),'inf'); % diff state from target
    dia(3,i)=norm(y(np+1:2*np,i)-u0(np+1:2*np),'inf'); % diff costate from IC
    dia(4,i)=norm(y(np+1:2*np,i)-u1(np+1:2*np),'inf'); % diff costate from target
end
figure(wnr); set(gca,'FontSize',s1.plot.fs); 
plot(t,dia(1,:),'k',t,dia(2,:),'b',t,dia(3,:),'m',t,dia(4,:),'g','LineWidth',2); 
legend('||P-P_0||_\infty','||P-P_1||_\infty','||q-q_0||_\infty','||q-q_1||_\infty'); 
rho=s1.u(s1.nu+1); jp=jcaiT(s1,sol,rho)+disjcaT(s1,sol,rho,0); % jca of path
j0=jca(s1,p.u0)/rho; j1=jca(s1,s1.u)/rho; 
%tit=[fn.sd0 '/' fn.sp0 ' to ' fn.sd1 '/' fn.sp1 '_{.}']; 
fprintf('J0=%g, Jp=%g, J1=%g\n',j0,jp,j1); 
tit={['J_0=' mat2str(j0,3) ',  J=' mat2str(real(jp),3) ',  J_1=' mat2str(j1,3)]}; 
figure(wnr); set(gca,'FontSize',14); title(tit); axis tight;
